﻿Public Class Form1

    'Transactionオブジェクト
    Dim trans As SqlClient.SqlTransaction

    'ボタンの有効・無効をセットするメソッド
    Private Sub AlterButton(ByVal flg As Boolean)
        Me.Button1.Enabled = flg
        Me.Button2.Enabled = flg
        Me.Button3.Enabled = Not flg
        Me.Button4.Enabled = Not flg
        Me.Button5.Enabled = Not flg
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        'データセットを一度クリアにする
        Me.DataSet11.Clear()

        'データセットを同期させる
        Me.SqlDataAdapter1.Fill(Me.DataSet11)
    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        'データベースを開く
        Me.SqlConnection1.Open()

        'トランザクションの開始
        Me.trans = Me.SqlConnection1.BeginTransaction

        'ボタンの表示設定
        Me.AlterButton(False)
    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        'トランザクションの確定
        Me.trans.Commit()

        'データベースを閉じる
        Me.SqlConnection1.Close()

        'ボタンの表示設定
        Me.AlterButton(True)
    End Sub

    Private Sub Button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button4.Click
        'トランザクションの取消
        Me.trans.Rollback()

        'データベースを閉じる
        Me.SqlConnection1.Close()

        'ボタンの表示設定
        Me.AlterButton(True)
    End Sub

    Private Sub Button5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button5.Click
        'データを追加するSQL文生成
        Dim sql As String = "INSERT INTO M_ユーザー VALUES(@id, @user, @pass, @name)"
        System.Diagnostics.Debug.WriteLine("SQLステートメント:" & sql)

        'コマンドオブジェクトの生成
        Dim cmd As SqlClient.SqlCommand = New SqlClient.SqlCommand(sql, Me.SqlConnection1)

        'トランザクションのセット
        cmd.Transaction = Me.trans

        'パラメータのセット
        cmd.Parameters.Add("@id", SqlDbType.VarChar).Value = Me.TextBox1.Text
        cmd.Parameters.Add("@user", SqlDbType.VarChar).Value = Me.TextBox2.Text
        cmd.Parameters.Add("@pass", SqlDbType.VarChar).Value = Me.TextBox3.Text
        cmd.Parameters.Add("@name", SqlDbType.VarChar).Value = Me.TextBox4.Text
        cmd.ExecuteNonQuery()
    End Sub
End Class
